unit uDebugger;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, uTypes, ComCtrls;

type
  TVariable = record
    Name, Wert : String;
  end;

  TDebugger = class
    constructor Create;
    destructor Destroy; override;
  private
    Form : TForm;
    LV   : TListView;
    Vars : Array of TVariable;
    procedure AddArr(Name, Wert : String);
  public
    procedure Add(Name : String; i : Integer); overload;
    procedure Add(Name : String; f : Real)   ; overload;
    procedure Add(Name : String; b : Boolean); overload;
    procedure Add(Name : String; s : String ); overload;
    procedure Write;
    procedure Show(aForm : TForm);
  end;

var
  Debugger : TDebugger;

implementation

constructor TDebugger.Create;
begin
  Form := TForm.Create(nil);
  with Form do
  begin
    Caption  := 'Debugger';
    Position := poScreenCenter;
    Height   := 500;
  end;

  LV := TListView.Create(nil);
  with LV do
  begin
    Parent := Form;
    Align  := alClient;
    with Columns.Add do
    begin
      Caption := 'Sender';
      Width   := LV.Width div 2;
    end;
    with Columns.Add do
    begin
      Caption := 'Nachricht';
      Width   := LV.Width div 2;
    end;
    ViewStyle := vsReport;
    Show;
  end;
end;

destructor TDebugger.Destroy;
begin
  SetLength(Vars, 0);
  LV.Free;
  Form.Destroy;
end;

procedure TDebugger.AddArr(Name, Wert : String);
begin
  SetLength(Vars, Succ(Length(Vars)));
  Vars[High(Vars)].Name := Name;
  Vars[High(Vars)].Wert := Wert;
end;

procedure TDebugger.Add(Name : String; i : Integer);
begin
  AddArr(Name, IntToStr(i));
end;

procedure TDebugger.Add(Name : String; f : Real);
begin
  AddArr(Name, FloatToStr(f));
end;

procedure TDebugger.Add(Name : String; b : Boolean);
begin
  AddArr(Name, BoolToStr(b));
end;

procedure TDebugger.Add(Name : String; s : String );
begin
  AddArr(Name, s);
end;

procedure TDebugger.Write;
var i : Integer;
begin
  for i := 0 to High(Vars) do
  begin
    with LV do
    begin
      with LV.Items.Add do
      begin
        Caption := Vars[i].Name;
        SubItems.Add(Vars[i].Wert)
      end;
      if not Focused then
        Items[Pred(Items.Count)].MakeVisible(False);
    end;
  end;
  SetLength(Vars, 0);
end;

procedure TDebugger.Show(aForm : TForm);
begin
  if not Form.Visible then
  begin
    Form.Show;
    if aForm <> nil then
      aForm.SetFocus;
  end;
end;

procedure DbgDestroy;
begin
  {SetLength(Vars, 0);
  Form.LV.Destroy;
  Form.Destroy;  }
end;

end.
