unit uFunk;

{$MODE Delphi}

interface

uses
  SysUtils, Classes, uTypes, StrUtils, Graphics, fpImage, opbitmap, lazbridge;

type
  TRGBQuad = packed record
    B, G, R, A : Byte;
  end;
  PRGBQuad  =^TRGBQuad;
  TRGBarray = Array[0..0] of TRGBQuad;

function DurationMinSec(MS : Integer) : String;

function LoadDPL(f : String) : TDynStrArray;
function LoadASX(f : String) : TDynStrArray;
function FileType(f : String) : Integer; // 0=Video; 1=Audio
//function Rotate90(Source : TGraphic) : TPicture;
//function Rotate90(var Source : TBitmap) : TBitmap;
function Rotate90(var Source : TCanvasOpBitmap) : TBitmap;
//function PictureToBitmap(Picture : TPicture) : TBitmap;
function Floor(X : Extended) : Integer;

implementation

{function DurationMinSec(Sekunden : Integer) : String;
var Hour, Min, Sec : Integer;
begin
  Hour := Sekunden div 1440;
  dec(Sekunden, Hour*1440);
  Min  := Sekunden div 60;
  Sec  := Sekunden - Min * 60;
  if Boolean(Hour) then
    Result := Format('%d:%.2d:%.2d', [Hour, Min, Sec])
  else
    Result := Format('%.2d:%.2d', [Min, Sec]);
end;      }

function DurationMinSec(MS : Integer) : String;
var Hour, Min, Sec : Integer;
begin
  Sec  := MS div 1000;
  Hour := Sec div 3600;
  dec(Sec, Hour*3600);
  Min  := Sec div 60;
  Sec  := Sec-Min * 60;
  if Boolean(Hour) then
    Result := Format('%d:%.2d:%.2d', [Hour, Min, Sec])
  else
    Result := Format('%.2d:%.2d', [Min, Sec]);
end;

function LoadDPL(f : String) : TDynStrArray;
var sl : TStrings;
    i  : Integer;
    s  : String;
begin
  sl := TStringList.Create;
  with sl do
  begin
    LoadFromFile(f);
    for i := 0 to sl.Count-1 do
    begin
      if (sl[i] = '[DPL]') or (sl[i] = '[/DPL]') then
        Continue;
      s := StringReplace(sl[i], '[ENTRY]' , '', [rfReplaceAll, rfIgnoreCase]);
      s := StringReplace(s    , '[/ENTRY]', '', [rfReplaceAll, rfIgnoreCase]);
      SetLength(Result, Length(Result)+1);
      Result[High(Result)] := s;
    end;
    Free;
  end;
end;

function LoadASX(f : String) : TDynStrArray;
var sl      : TStringList;
    i       : Integer;
    erstes  : Integer;
    zweites : Integer;
    p, line : String;
begin
  sl := TStringList.Create;
  sl.LoadFromFile(f);
  for i := 0 to Pred(sl.Count) do
  begin
    line := UpperCase(sl[i]);
    if (Pos('HREF', line) >= 1) then
    begin
      erstes  := Pos('"', line)+1;
      zweites := PosEx('"', line, erstes);
      if zweites > erstes then
      begin
        p := Copy(line, erstes, zweites-erstes);
        SetLength(Result, Length(Result)+1);
        Result[High(Result)] := p;
      end;
    end;
  end;
  sl.Free;
end;

function FileType(f : String) : Integer; // 0=Video; 1=Audio
const FileExt : Array[0 ..13] of String = ('.mp3', '.wav', '.wma', '.aiff', '.aif', '.ogg', '.wmv', '.mpeg', '.mpg', '.dat', '.avi', '.m3u', '.asx', '.dpl');
var s : String;
    i : Integer;
begin
  Result := -1;

  s := Trim(LowerCase(f));
  for i := 0 to 10 do
    if FileExt[i] = s then
      Break;

  case i of
    0, 1, 2, 3, 4, 5:
    begin
      Result := 1;
    end;

    6, 7, 8, 9, 10, 11:
    begin
      Result := 0;
    end;
  end;
end;

{function Rotate90(Source : TGraphic) : TPicture;
var P          : PRGBQuad;
    Y, X, H, W : Integer;
    RowOut     : ^TRGBarray;
    SrcBmp     : TBitmap;
begin
  SrcBmp := TBitmap.Create;
  with SrcBmp do
  begin
    PixelFormat := pf32bit;
    Height      := Source.Height;
    Width       := Source.Width;
    Canvas.Draw(0, 0, Source);
  end;
  if Result <> nil then
    Result := TPicture.Create;
  Result.Bitmap.PixelFormat := pf32bit;

  W                    := SrcBmp.Height;
  H                    := SrcBmp.Width;
  Result.Bitmap.Height := H;
  Result.Bitmap.Width  := W;

  for Y := 0 to Pred(H) do
  begin
    RowOut := Result.Bitmap.ScanLine[Y];
    P := SrcBmp.ScanLine[Pred(SrcBmp.Height)];
    inc(P, Y);
    for X := 0 to Pred(W) do
    begin
      RowOut[X] := P^;
      inc(P, H);
    end;
  end;
  SrcBmp.Free;
end;   }

function Rotate90(var Source : TCanvasOpBitmap) : TBitmap;
var P              : PRGBQuad;
    Y, X, H, W     : Integer;
    RowOut         : ^TRGBarray;
    SrcBmp, EndBmp : TCanvasOpBitmap;
begin
  SrcBmp := TCanvasOpBitmap.Create;
  with SrcBmp do
  begin
    PixelFormat := pf32bit;
    Height      := Source.Height;
    Width       := Source.Width;
    Canvas.Draw(0, 0, Source);
  end;
  EndBmp := TCanvasOpBitmap.Create;
  EndBmp.PixelFormat := pf32bit;

  W             := SrcBmp.Height;
  H             := SrcBmp.Width;
  EndBmp.Height := H;
  EndBmp.Width  := W;

  for Y := 0 to Pred(H) do
  begin
    RowOut := EndBmp.ScanLine[Y];
    P := SrcBmp.ScanLine[Pred(SrcBmp.Height)];
    inc(P, Y);
    for X := 0 to Pred(W) do
    begin
      RowOut[X] := P^;
      inc(P, H);
    end;
  end;
  SrcBmp.Free;
  
  AssignOpBitmapToBitmap(EndBmp, Result);
end;{

function Rotate90(var Source : TCanvasOpBitmap) : TLazIntfImage;
var X, Y : Integer;
begin
  Result.SetSize(Source.Height, Source.Width);
  Result.FillPixels(colWhite); //! nötig ?
  
  Source.

  for X := 0 to Pred(Source.Width) do
    for Y := 0 to Pred(Source.Height) do
      Result.Colors[Pred(Result.Width-X), X]:= Source.Colors[X, Y];
end;   }
{function Rotate90(var Source : TBitmap) : TBitmap;
var P          : PRGBQuad;
    Y, X, H, W : Integer;
    RowOut     : ^TRGBarray;
    SrcBmp     : TBitmap;
begin
  SrcBmp := TBitmap.Create;
  with SrcBmp do
  begin
    PixelFormat := pf32bit;
    Height      := Source.Height;
    Width       := Source.Width;
    Canvas.Draw(0, 0, Source);
  end;
  Result := TBitmap.Create;
  Result.PixelFormat := pf32bit;

  W             := SrcBmp.Height;
  H             := SrcBmp.Width;
  Result.Height := H;
  Result.Width  := W;

  for Y := 0 to Pred(H) do
  begin
    RowOut := Result.ScanLine[Y];
    P := SrcBmp.ScanLine[Pred(SrcBmp.Height)];
    inc(P, Y);
    for X := 0 to Pred(W) do
    begin
      RowOut[X] := P^;
      inc(P, H);
    end;
  end;
  SrcBmp.Free;
end;        }

{function PictureToBitmap(Picture : TPicture) : TBitmap;
begin
  Result := TBitmap.Create;
  with Result do
  begin
    PixelFormat := pf32bit;
    Height      := Picture.Height;
    Width       := Picture.Width;
    Canvas.Draw(0, 0, Picture.Graphic);
  end;
end;     }

function Floor(X : Extended) : Integer;
begin
  Result := Integer(Trunc(X));
  if Frac(X) < 0 then
    Dec(Result);
end;

end.
